import QtQuick 2.12
import "../qml/"

Rectangle {
    id: backButton

    property string backState: "HomeState"

    signal clicked()
    signal backButtonClicked()
    onClicked: {
        main.state = backButton.backState;
        backButtonClicked()
        buzzer.buttonPress()
    }

    visible: true

    anchors.left: parent.left
    anchors.leftMargin: 35 * main.hScaleFactor
    anchors.bottom: parent.bottom
    anchors.bottomMargin: 53 * main.vScaleFactor

    height: 45 * main.vScaleFactor
    width: 53 * main.hScaleFactor
    radius: main.defaultRadius

    border.color: main.colorUIBorder
    border.width: main.widthBorder
    color: main.colorDialogBackground

    ScalableImage {
        anchors.fill: parent
        anchors.margins: 5 * main.scaleFactor
        fillMode: Image.PreserveAspectFit
        sourceName: "Components/ArrowLeftWhiteIcon";
    }

    MouseArea {
        anchors.fill: parent
        onClicked: backButton.clicked();

        Rectangle {
            anchors.fill: parent
            color: main.colorGenericStimulusArea
            opacity: 0.3
            visible: main.showStimulusArea
        }
    }
}
