import QtQuick 2.12
import "../qml/"

Rectangle {
    id: closeButton

    signal clicked()

    onClicked: {
        buzzer.buttonPress()
    }

    visible: true
    property bool  isTransparent: true

    width: 53 * main.hScaleFactor
    height: 45 * main.vScaleFactor
    radius: main.defaultRadius

    border.color: main.colorUIBorder
    border.width: main.widthBorder
    color: isTransparent ? main.colorButtonBackground : main.colorDialogBackground

    ScalableImage {
        anchors.fill: parent
        anchors.centerIn: parent
        anchors.margins: 0.3 * parent.height
        fillMode: Image.PreserveAspectFit
        sourceName: "Components/tools_close";
    }

    MouseArea {
        anchors.fill: parent
        onClicked: closeButton.clicked();

        Rectangle {
            anchors.fill: parent
            color: main.colorGenericStimulusArea
            opacity: 0.3
            visible: main.showStimulusArea
        }
    }
}
