.pragma library
// Global definitions

function secondsToTime(secs)
{
    var hours = Math.floor(secs / 3600)
    var divisor_for_minutes = secs % 3600
    var minutes = Math.floor(divisor_for_minutes / 60)
    var seconds = divisor_for_minutes % 60

    var timestr = (hours > 0 ? hours+":" : "") +
    (hours > 0 ? padZeros(minutes, 2) : minutes) + ":" +
    padZeros(seconds, 2)

    return timestr
}

function secondsToMSString(secs) {
    // Display in MM:SS format - e.g. 88:43
    var minutes = Math.floor(secs / 60)
    var seconds = secs - minutes*60

    var timestr = (minutes == 0 ? "00" : minutes) + ":" + padZeros(seconds, 2)
    return timestr

}

function poundToKg(lbs){
    var kg;
    //@todo Add bounds guard..
    kg = (lbs * 10) / 22;
    return kg;
}

function kgToPound(kg){
    var lbs;
    //@todo Add bounds guard..
    lbs = (kg * 22) / 10;
    return lbs;
}

function mileToKm(mile){
    return mile * 1.609344
}

function cmToInch(cm) {
    return cm / 2.54
}

function inchToCm(inch) {
    return inch * 2.54
}

function kmToMile(km){
    return km * 0.6213712
}

function feetToMeters(feet) {
    return feet / 3.28084
}

function metersToFeet(meters) {
    return meters * 3.28084
}

function formatWithSeparator(value) {
    // Add comma or other separator
    return Number(value).toLocaleString()
}

function inchTomm(inch){
    var mm;
    mm = inch * 25;
    mm += (inch * 4) / 10;
    return mm;
}

function mmToInch(mm){
    var inch;
    inch = (mm * 100) / 254;
    return inch;
}

// Get string representation of an object, getting around JSON.stringify's
// "cannot serialize cyclic structures" error.
function objToString(obj) {
    var seen = [];

    return JSON.stringify(obj, function(key, val) {
       if (typeof val === "object") {
            if (seen.indexOf(val) >= 0) {
                return "[cycle]";
            }
            seen.push(val);
        }
        return val;
    });
}

function padZeros(val, width) {
    var padWidth = width - val.toString().length
    if (padWidth > 0) {
        while (padWidth--) {
            val = "0" + val
        }
    }
    return val
}

function stripLeadingZeros(str) {
    str = parseInt(str,10)
    return str.toString()
}

Array.prototype.findIndex = function(f) {
    for (var i = 0; i < this.length; i++) {
        if (f(this[i]))
            return i
    }

    return -1 // not found
}

// Truncate to a max length of `maxLength`, including the ... characters
function truncate(str, maxLength) {
    if (str.length + 3 >= maxLength) {
        return str.substr(0, maxLength - 3) + "..."
    }
    return str
}
