import QtQuick 2.12

Rectangle {
    id: root

    property bool showLabel: false
    property string borderColor: main.colorUIBorder
    property string backgroundColor: "transparent"
    property string fillColor: borderColor
    property int value: 0

    color: backgroundColor
    border.color: borderColor
    border.width: 3 * main.scaleFactor
    radius: 5 * main.scaleFactor

    Rectangle {
        id: bar
        anchors { left: parent.left; top: parent.top ; bottom: parent.bottom }
        radius: 5 * main.scaleFactor
        color: fillColor
        width: value * parent.width / 100
        height: parent.height
        z: parent.z - 1
    }

    NumberLabel {
        text: (value | 0) + "%"
        anchors.fill: parent
        horizontalAlignment: Text.AlignHCenter
        verticalAlignment: Text.AlignVCenter
        visible: showLabel
    }
}

