import QtQuick 2.12

// This object provides a scrollable container for a ListView
//Calling object needs to provide size, anchors, model, and delegate

Rectangle {
    id: root

    property alias model: scrollListView.model
    property alias delegate: scrollListView.delegate
    property alias spacing: scrollListView.spacing
    property alias currentIndex: scrollListView.currentIndex

    property string backgroundColor: "white"//"lightgrey"
    color: backgroundColor

    Rectangle {
        id: sliderBar

        anchors .right: parent.right
        anchors.rightMargin: 2 * main.hScaleFactor
        width: 15 * main.hScaleFactor
        height: scrollListView.height * scrollListView.height/scrollListView.contentHeight
        visible: scrollListView.height < scrollListView.contentHeight
        color: "darkgrey"
        radius: main.defaultRadius
        y: (parent.height - height) * scrollListView.contentY / (scrollListView.contentHeight - scrollListView.height)
    }

    ListView {
        id:scrollListView

        anchors {
            top: parent.top
            bottom: parent.bottom
            left: parent.left
            right: sliderBar.left
        }

        interactive: true
        snapMode: ListView.SnapToItem
        clip: true
    }
}
