import QtQuick 2.12

ModalDialog {
    id: root

    property string message: "Notice"
    property bool hideWhen: false // expression that overrides visible setting
    property bool beep: true

    Component.onCompleted: hide()
    onTimedOut: hide()  // hide the pop-up when timer expires

    function showMessage(string, seconds) {
        message = string
        showWithTimeout(seconds)
    }

    function showWithTimeout(seconds) {
        if (beep) {
            buzzer.buttonPress()
        }
        startTimeout(seconds)
        show()
    }

    function show() {
        if (!hideWhen) {
            dialogManager.alertShown(root)
            visible = true
        }
   }

    width: 1000
    height: 58

    Text {
        id: bannerText
        anchors.verticalCenter: root.verticalCenter
        anchors.horizontalCenter: root.horizontalCenter
        horizontalAlignment: Text.AlignHCenter
        verticalAlignment: Text.AlignVCenter
        scale: paintedWidth > (root.width-40) ? ((root.width - 40)/ paintedWidth) : 1
        height: root.height
        width: paintedWidth
        color: main.colorFontLight
        text: root.message
        opacity: 0.8
        font.bold: false
        font.pixelSize: 40
        z: root.z + 1
    }
}
