import QtQuick 2.12
import FileIO 1.0
import StorageMgr 1.0

Item {
    id: root

    property string source: ""
    property string destination: ""

    function deleteCurrentVideos() {
        var filesToDelete = storageMgr.listFiles(root.destination, ["*.mpg", "*.mpeg", "*.avi", "*.mp4", "*.jpg", "*.jpeg", "*.png", "*.bmp"])
        for (var i = 0; i < filesToDelete.length; i++) {
            var fullpath = root.destination + "/" + filesToDelete[i]
            var res = fileio.remove(fullpath)
            if (!res) {
                console.log("!! file remove failed", source)
            }
        }
    }

    function commitVideo() {
        root.deleteCurrentVideos()

        // create destination directory if it does not exist
        storageMgr.createDirectory(root.destination)

        var videos = storageMgr.listFiles(root.source, ["*.mpg", "*.mpeg", "*.avi", "*.mp4", "*.jpg", "*.jpeg", "*.png", "*.bmp"])

        if(videos.length > 0) {
            var src = root.source + "/" + videos[0]
            var dst = root.destination + "/" + videos[0]
            var res = fileio.copy(src, dst)
            if (!res) {
                console.log("!! file copy failed", src, dst)
            }
        }
    }

    FileIO {
        id: fileio
        onError: print("IO error: " + error)
    }

    StorageMgr {
        id: storageMgr
    }
}
