import QtQuick 2.12
import ".."
import Components 1.0

Item{
    id: root
    anchors.fill: parent

    property bool isSetupWizard: false

    signal declineTogglePressed()

    onDeclineTogglePressed: saveButton.visible = !root.isSetupWizard

    Component.onCompleted: {
        nucleus.getOptions()
    }

    Connections {
        target: nucleus
        onTreadmillSetInclineOptionCompleted: {
            if(result === true && !isSetupWizard) {
                setOptionComplete.show()
            }
        }
    }

    ListModel {
        id: productListModel

        ListElement {
            name: "TES900"
            imageName: "../graphics/ui3_0/product_images/2013/TRU_TES900_sideview.png"
        }
        ListElement {
            name: "TCS400"
            imageName: "../graphics/ui3_0/product_images/2013/TRU_TCS400_sideview.png"
        }
        ListElement {
            name: "TCS600"
            imageName: "../graphics/ui3_0/product_images/2013/TRU_TCS600_sideview.png"
        }
        ListElement {
            name: "TCS650"
            imageName: "../graphics/ui3_0/product_images/2013/TRU_TCS650_sideview.png"
        }
        ListElement {
            name: "TCS900"
            imageName: "../graphics/ui3_0/product_images/2013/TRU_TCS900_sideview.png"
        }
        ListElement {
            name: "TPS825"
            imageName: "../graphics/ui3_0/product_images/2013/TRU_TES900_sideview.png"
        }
        ListElement {
            name: "XCS400"
            imageName: "../graphics/ui3_0/product_images/2013/TRU_XCS400_sideview.png"
        }
        ListElement {
            name: "XCS900"
            imageName: "../graphics/ui3_0/product_images/2013/TRU_XCS900_sideview.png"
        }
        ListElement {
            name: "TS1000"
            imageName: "../graphics/ui3_0/product_images/2015/TRU_TS1000_sideview.png"
        }
        ListElement {
            name: "RCS400"
            imageName: "../graphics/ui3_0/product_images/2013/TRU_RCS400_sideview.png"
        }
        ListElement {
            name: "UCS400"
            imageName: "../graphics/ui3_0/product_images/2013/TRU_UCS400_sideview.png"
        }
        ListElement {
            name: "UCS900"
            imageName: "../graphics/ui3_0/product_images/2013/TRU_UCS900_sideview.png"
        }
        ListElement {
            name: "RCS900"
            imageName: "../graphics/ui3_0/product_images/2013/TRU_RCS900_sideview.png"
        }
        ListElement {
            name: "TL1000"
            imageName: "../graphics/ui3_0/product_images/2018/XL1000.png"
        }
        ListElement {
            name: "XL1000"
            imageName: "../graphics/ui3_0/product_images/2018/XL1000.png"
        }
        ListElement {
            name: "TI1000"
            imageName: "../graphics/ui3_0/product_images/2018/TI1000.png"
        }
        /* Following elements uses new model names for each machine */
        ListElement {
            name: "TE900"
            imageName: "../graphics/ui3_0/product_images/2018/TE900.png"
        }
        ListElement {
            name: "TC400"
            imageName: "../graphics/ui3_0/product_images/2018/TC400.png"
        }
        ListElement {
            name: "TC600"
            imageName: "../graphics/ui3_0/product_images/2018/TC400.png"
        }
        ListElement {
            name: "TC650"
            imageName: "../graphics/ui3_0/product_images/2018/TC650.png"
        }
        ListElement {
            name: "TC900"
            imageName: "../graphics/ui3_0/product_images/2018/TC900.png"
        }
        ListElement {
            name: "TR950"
            imageName: "../graphics/ui3_0/product_images/TR950.png"
        }
        ListElement {
            name: "XC400"
            imageName: "../graphics/ui3_0/product_images/2018/XC400.png"
        }
        ListElement {
            name: "XC900"
            imageName: "../graphics/ui3_0/product_images/2018/XC900.png"
        }
        ListElement {
            name: "XS1000"
            imageName: "../graphics/ui3_0/product_images/2018/XS1000.png"
        }
        ListElement {
            name: "RC400"
            imageName: "../graphics/ui3_0/product_images/2018/RC400.png"
        }
        ListElement {
            name: "UC400"
            imageName: "../graphics/ui3_0/product_images/2018/UC400.png"
        }
        ListElement {
            name: "UC900"
            imageName: "../graphics/ui3_0/product_images/2018/UC900.png"
        }
        ListElement {
            name: "UC920"
            imageName: "../graphics/ui3_0/product_images/2018/UC900.png"
        }
        ListElement {
            name: "RC900"
            imageName: "../graphics/ui3_0/product_images/2018/RC900.png"
        }
        ListElement {
            name: "RC921"
            imageName: "../graphics/ui3_0/product_images/2018/RC900.png"
        }
        ListElement {
            name: "VC900"
            imageName: "../graphics/ui3_0/product_images/2018/VC900.png"
        }
        ListElement {
            name: "ST1000"
            imageName: "../graphics/ui3_0/product_images/ST1000.png"
        }
    }

    TextLabel {
        id: title
        text: qsTr("PRODUCT ID")
        color: main.colorFontDark
        anchors.top: parent.top
        anchors.left: parent.left
        anchors.leftMargin: 30 * main.hScaleFactor
        font.pixelSize: 24 * main.vScaleFactor
    }

    Item {
        id: productImageArea
        height: 0.5 * parent.height
        width: parent.width * 0.45
        anchors.left: parent.left
        anchors.top: title.bottom

        Image{
            id:productImage
            anchors.fill: parent
            fillMode: Image.PreserveAspectFit
            smooth: true
            source: getImageElementFromModelString(machineinfo.modelString)
        }
    }

    Item {

        id: machineConfigurationArea
        width: 0.5 * parent.width
        height: 0.6 * parent.height

        anchors {
            top: parent.top
            right: parent.right
        }

        TextLabel {
            id: currentProductTypeText
            text: machineinfo.modelString + " " + qsTr(machineinfo.productTypeString) + application.emptyString
            font.pixelSize: 22 * main.vScaleFactor
            color: main.colorFontDark
            anchors.top: parent.top
            anchors.horizontalCenter: parent.horizontalCenter
        }

        Grid {
            id: modelInfoBlock
            property int fontSize: 14 * main.vScaleFactor
            property int colWidth: (parent.width - columnSpacing)/2

            rowSpacing: 20 * main.vScaleFactor
            columnSpacing : 40 * main.hScaleFactor
            columns: 2
            rows: 7
            verticalItemAlignment: Grid.AlignVCenter

            width: parent.width
            height: parent.height - currentProductTypeText.height
            anchors.top: currentProductTypeText.bottom
            anchors.topMargin: 50 * main.vScaleFactor

            TextLabel {
                text: qsTr("MODEL #") + application.emptyString
                font.pixelSize: modelInfoBlock.fontSize
                color: main.colorFontDark
                width: modelInfoBlock.colWidth
                horizontalAlignment: Text.AlignRight
            }

            TextLabel {
                text: machineinfo.modelString + application.emptyString
                font.pixelSize: modelInfoBlock.fontSize
                color: main.colorFontDark
                width: modelInfoBlock.colWidth
                horizontalAlignment: Text.AlignLeft
            }

            TextLabel {
                text: qsTr("BASE SERIAL #") + application.emptyString
                font.pixelSize: modelInfoBlock.fontSize
                color: main.colorFontDark
                width: modelInfoBlock.colWidth
                horizontalAlignment: Text.AlignRight
            }

            TextLabel {
                text: (main.lowerSystem === "NUCLEUS" ? (machineinfo.serialNumber) : qsTr("Not Available") ) + application.emptyString
                font.pixelSize: modelInfoBlock.fontSize
                color: main.colorFontDark
                width: modelInfoBlock.colWidth
                horizontalAlignment: Text.AlignLeft
            }

            TextLabel {
                text: qsTr("CONSOLE TYPE") + application.emptyString
                font.pixelSize: modelInfoBlock.fontSize
                color: main.colorFontDark
                width: modelInfoBlock.colWidth
                horizontalAlignment: Text.AlignRight
            }

            TextLabel {
                text: main.consoleType + application.emptyString
                font.pixelSize: modelInfoBlock.fontSize
                color: main.colorFontDark
                width: modelInfoBlock.colWidth
                horizontalAlignment: Text.AlignLeft
            }

            TextLabel {
                text: qsTr("CONSOLE SERIAL #") + application.emptyString
                font.pixelSize: modelInfoBlock.fontSize
                color: main.colorFontDark
                width: modelInfoBlock.colWidth
                horizontalAlignment: Text.AlignRight
            }

            TextLabel {
                text: main.serialNumber + application.emptyString
                font.pixelSize: modelInfoBlock.fontSize
                color: main.colorFontDark
                width: modelInfoBlock.colWidth
                horizontalAlignment: Text.AlignLeft
            }

            TextLabel {
                text: qsTr("STRIDE LENGTH RANGE") + application.emptyString
                font.pixelSize: modelInfoBlock.fontSize
                color: main.colorFontDark
                width: modelInfoBlock.colWidth
                horizontalAlignment: Text.AlignRight
                visible: (machineinfo.modelString === "XS1000" || machineinfo.modelString === "TS1000")
            }

            TextLabel {
                text: (machineinfo.adjustableStrideEllipticalMinStrideIn / 10).toFixed(1) + qsTr(" to ") + (machineinfo.adjustableStrideEllipticalMaxStrideIn / 10).toFixed(1) + qsTr(" Inches")
                font.pixelSize: modelInfoBlock.fontSize
                color: main.colorFontDark
                width: modelInfoBlock.colWidth
                horizontalAlignment: Text.AlignLeft
                visible: (machineinfo.modelString === "XS1000" || machineinfo.modelString === "TS1000")
            }

            TextLabel {
                text: qsTr("SPEED RANGE") + application.emptyString
                font.pixelSize: modelInfoBlock.fontSize
                color: main.colorFontDark
                width: modelInfoBlock.colWidth
                horizontalAlignment: Text.AlignRight
                visible: nucleus.machineTypeString === "Treadmill"
            }

            TextLabel {
                text: main.isStepmill ?
                        machineinfo.stepmillSpeedMinSpm.toFixed(0) + qsTr(" to ") + machineinfo.stepmillSpeedMaxSpm.toFixed(0) :
                         (machineinfo.treadmillSpeedMinMph / 10).toFixed(1) + qsTr(" to ") + (machineinfo.treadmillSpeedMaxMph / 10).toFixed(1) + qsTr("MPH")
                font.pixelSize: modelInfoBlock.fontSize
                color: main.colorFontDark
                width: modelInfoBlock.colWidth
                horizontalAlignment: Text.AlignLeft
                visible: main.isStepmill || main.isTreadmill
            }

            TextLabel {
                text: qsTr("INCLINE RANGE") + application.emptyString
                font.pixelSize: modelInfoBlock.fontSize
                color: main.colorFontDark
                width: modelInfoBlock.colWidth
                horizontalAlignment: Text.AlignRight
                visible: nucleus.machineTypeString === "Treadmill"
            }

            TextLabel {
                text: (machineinfo.treadmillInclineMinPercentGrade / 10).toFixed(1) + "%" + qsTr(" to ") + (machineinfo.treadmillInclineMaxPercentGrade / 10).toFixed(1) + "%"
                font.pixelSize: modelInfoBlock.fontSize
                color: main.colorFontDark
                width: modelInfoBlock.colWidth
                horizontalAlignment: Text.AlignLeft
                visible: nucleus.machineTypeString === "Treadmill"
            }
        }
    }

    TextLabel {
        id: declineOptionTitle
        anchors.top: productImageArea.bottom
        anchors.topMargin: 50 * main.vScaleFactor
        text: qsTr("DECLINE OPTION INSTALLED?") + application.emptyString
        color: main.colorFontDark
        font.pixelSize: 16 * main.vScaleFactor
        visible: nucleus.declineOption && nucleus.machineTypeString === "Treadmill"
    }

    Grid {
        id: declineOptionsGrid
        anchors.top: declineOptionTitle.bottom
        anchors.topMargin: 10 * main.vScaleFactor

        visible: nucleus.declineOption && nucleus.machineTypeString === "Treadmill"
        width: 1.5*productImageArea.width
        height: 0.45 * parent.height
        rows: 2
        columns: 2
        columnSpacing: 30 * main.hScaleFactor
        rowSpacing: 10 * main.hScaleFactor
        verticalItemAlignment: Grid.AlignVCenter

        property bool declineSelected: machineinfo.treadmillInclineMinPercentGrade < 0
        onDeclineSelectedChanged: {
            yesDeclineCheckbox.value = declineSelected
            noDeclineCheckbox.value = !declineSelected
        }

        Rectangle {
            width: 0.35 * declineOptionsGrid.width
            height: 0.38 * declineOptionsGrid.height
            border.color: main.colorDiagnosticEdges
            border.width: 2
            color: "transparent"

            ScalableImage {
                sourceName: "product_images/DeclineInstalled"
                anchors.fill: parent
            }
        }

        Checkbox {
            id: yesDeclineCheckbox
            label: qsTr("YES, DECLINE") + application.emptyString

            width: 0.45 * declineOptionsGrid.width

            value: declineOptionsGrid.declineSelected
            onPressed: {
                declineOptionsGrid.declineSelected = value;
                nucleus.treadmillSetDeclineOption()
            }
        }

        Rectangle {
            width: 0.35 * declineOptionsGrid.width
            height: 0.38 * declineOptionsGrid.height
            border.color: main.colorDiagnosticEdges
            border.width: 2
            color: "transparent"

            ScalableImage {
                sourceName: "product_images/DeclineNotInstalled"
                anchors.fill: parent
            }
        }

        Checkbox {
            id: noDeclineCheckbox
            label: qsTr("NO DECLINE") + application.emptyString

            width: 0.45 * declineOptionsGrid.width

            value: !declineOptionsGrid.declineSelected
            onPressed: {
                declineOptionsGrid.declineSelected = !value
                nucleus.treadmillSetNonDeclineOption()
            }
        }

    }

    function getImageElementFromModelString(modelStr)
    {
        var i
        for(i = 0; i < productListModel.count; i++) {
            var item = productListModel.get(i)
            if(item.name === modelStr) {
                return item.imageName;
            }
        }
        return "";
    }



    MessagePopup {   // pop-up dialog background
        id: setOptionComplete
        message: qsTr("Power Cycle Required.")
    }
}
