import QtQuick 2.12
import Process 0.1
import Components 1.0

Item {
    id: root

    anchors.fill: parent

    property string scriptsdir: "/usr/lib/trueui/scripts"

    Rectangle {
        id: pointer

        color: "red"
        width: 8 * main.hScaleFactor
        height: 8 * main.vScaleFactor
        radius: 2 * main.scaleFactor

    }

    MouseArea {
        anchors.fill: parent
        onClicked: {
            pointer.x = mouseX - pointer.width/2
            pointer.y = mouseY - pointer.height/2
            buzzer.buttonPress()
        }
    }

    StandardButton {
        id: calButton

        width: 150 * main.hScaleFactor
        height: 78 * main.vScaleFactor
        anchors.left: parent.left
        anchors.bottom: parent.bottom
        anchors.bottomMargin: 25 * main.vScaleFactor

        buttonText: qsTr("calibrate") + application.emptyString
        onClicked: calProcess.start()
    }

    Process {
        id: calProcess

        program: root.scriptsdir + "/touch_calibration.sh"
        onStarted: print("touch calibration started.")
    }
}
