import QtQuick 2.12
import Process 0.1
import Components 1.0

Rectangle {
    id: root
    width: 500 * main.hScaleFactor
    height: 250 * main.vScaleFactor

    color: main.colorDialogBackground

    signal close()

    Component.onCompleted: {
        infoList.clear()
        machineinfo.readLowerboardInfo()
    }

    Connections {
        target: machineinfo
        onLowerboardInfoReceived: {
            var i
            for(i = 0; i < lowerboardInfo.length; i++){
                var element = { "infoItem":lowerboardInfo[i] }
                infoList.append(element)
            }
        }
    }

    CloseButton {
        id: closeButton

        isTransparent: false
        anchors {
            left: parent.right
            leftMargin: 5 * main.hScaleFactor
            top: parent.top
        }
        onClicked: close()
    }

    ListView {
        id: listView

        clip: true
        height: parent.height
        anchors.fill: parent

        delegate: Item {
            width: parent.width
            height: infoItemLabel.paintedHeight
            Text {
                id: infoItemLabel
                text: infoItem ? infoItem : "" ;
                height: paintedHeight
                width: paintedWidth
                anchors.left: parent.left
                anchors.leftMargin: 10 * main.hScaleFactor
                horizontalAlignment: Text.AlignLeft
                font.pixelSize: 30 * main.vScaleFactor;
                color: main.colorFontLight
            }
        }

        model: infoList
    }

    ListModel {
        id: infoList
    }

    focus: true
}
