// MessagePopup - A modal rectoval pop-up window with a text message.  Optional timeout.

import QtQuick 2.12
import Components 1.0

ModalDialog{
    id: root

    property string userDisplayText: qsTr("Console Not Available\nMaintenance in Progress") + application.emptyString
    property alias messageColor: popupText.color
    property string message: userDisplayText
    property int xOffset: 332
    property int yOffset: 161
    property bool clickThrough: false

    onTimedOut: hide()  // hide the pop-up when timer expires
    visible: false

    Item {
        z: root.z + 1
        anchors.fill: parent

        Text {
            id: popupText

            anchors.fill: parent
            anchors.margins: 30 * main.vScaleFactor
            anchors.verticalCenter: parent.verticalCenter
            color: "#ffffff"
            anchors.horizontalCenter: parent.horizontalCenter
            horizontalAlignment: Text.AlignHCenter
            verticalAlignment: Text.AlignVCenter
            wrapMode: Text.WordWrap
            font.bold: false
            font.pixelSize: 50 * main.vScaleFactor
            text: root.message
        }

        MouseArea{
            anchors.fill: parent
            onClicked: {
                if(dismissable) {
                    root.dismissed()
                }

                buzzer.buttonPress()
            }
            visible: !clickThrough

            Rectangle {
                anchors.fill: parent
                color: main.colorGenericStimulusArea
                opacity: 0.3
                visible: main.showStimulusArea
            }
        }

    }
}
