import QtQuick 2.12
import Components 1.0

Item {
    id: root
    property bool anyAreBlockingKeys: false
    property bool anyAreShown: false

    property variant hash: []
    function dm_alertShown(obj) {
        // object gets converted to a string when used as a key, which gives a way to track the object's identity
        hash[obj] = obj
    }

    function dm_alertHidden(obj) {
        delete hash[obj]
    }

    function dm_anyAreBlockingKeys() {
        for (var k in hash) {
            if (hash.hasOwnProperty(k)) {
                if (hash[k].blockKeys)
                    return true
            }
        }
        return false
    }

    function dm_anyAreShown() {
        for (var k in hash) {
            if (hash.hasOwnProperty(k)){
                if (hash[k].isTop) { // only count pop-ups that are always on top
                    return true
                }
            }
        }
        return false
    }

    function alertShown(obj) {
        dm_alertShown(obj)
        root.anyAreBlockingKeys = dm_anyAreBlockingKeys()
        root.anyAreShown = dm_anyAreShown()
    }

    function alertHidden(obj) {
        dm_alertHidden(obj)
        root.anyAreBlockingKeys = dm_anyAreBlockingKeys()
        root.anyAreShown = dm_anyAreShown()
    }
}
