import QtQuick 2.12
import Components 1.0
import ".."
import "../HomeScreen"

StandardPage {
    id: language_page
    width: main.width
    height: main.height

    signal languageSelected(string lang)
    property bool homeEnabled: main.state !== "DiagnosticState"
    
    title: (homeEnabled ? qsTr("LANGUAGE") : "" ) + application.emptyString
    image_width: 0.4

    banner_home_button: homeEnabled
    backState: main.state;
    showBackButton: true

    onBackButtonClicked: {
        if (homeEnabled) {
            main.state = "HomeState";
        } else {
            language_page.opacity = 0;
        }
    }

    contentSource: "LanguageSelectionComponent.qml"

    StandardIcon { // Lock Icon
        id: lock_icon
        width: 51 * main.hScaleFactor
        height: 37 * main.vScaleFactor
        anchors {
            top: language_page.top
            topMargin: 16 * main.vScaleFactor
            right: language_page.right
            rightMargin: 25 * main.hScaleFactor
        }
        onPressAndHold: screen_lock_overlay.open()

        sourceName: "HomeScreen/LOCK_ICON";
    }

    // screen lock which is opened when lock icon is pressed
    ScreenLock {
        id: screen_lock_overlay
        z:99
        lockTime: 20
        visible: false
    }

    Component.onCompleted: {
        contentItem.languageSelected.connect(languageSelected)
    }
}
