import QtQuick 2.12
import Components 1.0
import ".."
import "language.js" as LanguageJS

Item {
    id: languageGrid

    signal languageSelected(string lang)

    width: 845 * main.hScaleFactor

    Grid {
        id: language_buttons

        y: 20 * main.vScaleFactor
        x: (main.state === "DiagnosticState" ? 120 : (main.state ===  "SetupWizardState" ?  50 : 186 ) ) * main.hScaleFactor
        columns: 2
        rows: 6
        rowSpacing: 25 * main.vScaleFactor
        columnSpacing: 89 * main.hScaleFactor

        Repeater {
            id: gridRepeater

            model: ["en","ar","fr","ru","es","ja","nl","zh","it","pt","de","ko"]

            StandardButton {
                width: 192 * main.hScaleFactor
                height: 79 * main.vScaleFactor
                onClicked: languageSelected(modelData);
                selected: (modelData === application.currentLanguage)
                wideImage: true

                icon.sourceName: LanguageJS.getLanguageIcon(modelData)
                buttonText: LanguageJS.getLanguageName(modelData)
            }
        }
    }
}
