
/*
* This function returns the human-readable name
* of a language, given the language code.
*/
function getLanguageName(lang) {
    switch(lang) {
    case "en":
        return qsTr("ENGLISH")    + application.emptyString
    case "es":
        return qsTr("SPANISH")    + application.emptyString
    case "fr":
        return qsTr("FRENCH")     + application.emptyString
    case "de":
        return qsTr("GERMAN")     + application.emptyString
    case "it":
        return qsTr("ITALIAN")    + application.emptyString
    case "nl":
        return qsTr("DUTCH")      + application.emptyString
    case "pt":
        return qsTr("PORTUGUESE") + application.emptyString
    case "ru":
        return qsTr("RUSSIAN")    + application.emptyString
    case "ja":
        return qsTr("JAPANESE")   + application.emptyString
    case "ko":
        return qsTr("KOREAN")     + application.emptyString
    case "zh":
        return qsTr("CHINESE")    + application.emptyString
    case "ar":
        return qsTr("ARABIC")     + application.emptyString
    }
    return ""
}

/*
* This functions returns the name of the icon file associated with the
* given language code.  This functions does not return the full path
* to the LanguageMenu/ directory, where these files are.
*/
function getLanguageIcon(lang) {
    switch(lang) {
    case "en":
        return "LanguageMenu/Language_USA"
    case "es":
        return "LanguageMenu/Language_Spanish"
    case "fr":
        return "LanguageMenu/Language_French"
    case "de":
        return "LanguageMenu/Language_German"
    case "it":
        return "LanguageMenu/Language_Italian"
    case "nl":
        return "LanguageMenu/Language_Nederlandse"
    case "pt":
        return "LanguageMenu/Language_Portuguese"
    case "ru":
        return "LanguageMenu/Language_Russian"
    case "ja":
        return "LanguageMenu/Language_Japanese"
    case "ko":
        return "LanguageMenu/Language_Korean"
    case "zh":
        return "LanguageMenu/Language_Mandarin"
    case "ar":
        return "LanguageMenu/Language_Saudiarabia"
    }
    return ""
}
