import QtQuick 2.12
import Components 1.0

ModalDialog {
    id: root
    blockKeys: true
    opacity: 1

    signal jumpStart()

    onCountDownChanged: {
        main.workoutKeysDisabled = true
        if(countDown == 1) {
            jumpStart()
            console.debug("Jump START!")
        }
    }

    Item {
        z: root.z + 1
        anchors.fill: parent

        TextLabel {
            id: warningText
            width: 0.9*root.width
            height: 99 * main.vScaleFactor
            color: main.colorFontLight
            text: qsTr("WORKOUT BEGINNING IN") + application.emptyString
            anchors.horizontalCenter: parent.horizontalCenter
            anchors.top: parent.top
            anchors.topMargin: 35 * main.vScaleFactor
            horizontalAlignment: Text.AlignHCenter
            wrapMode: Text.WordWrap
            font.pixelSize: 40 * main.vScaleFactor
        }

        NumberLabel { // show count down to timeout of prompt (started by startTimeout(seconds) method of ModalDialog superclass
            id: countdownText
            color: main.colorFontLight
            text: countDown
            font.pixelSize: 96 * main.vScaleFactor
            width: 0.9*root.width
            anchors.top: warningText.bottom
            anchors.topMargin: 10 * main.vScaleFactor
            anchors.horizontalCenter: parent.horizontalCenter
            horizontalAlignment: Text.AlignHCenter
        }
    }
}
