import QtQuick 2.12
import Components 1.0
import "../views"
import "../string_format.js" as Format
import ".."

Item {
    id: root

    width: 0.88*main.width

    property variant profile1model
    property variant profile2model
    property string profile1Title
    property string profile2Title
    property bool saveHasHappened: false

    Item {
        id: summaryProfileGraph

        width: 0.78*main.width
        height: 0.4*main.height
        x: 230 * main.hScaleFactor
        y: 90 * main.vScaleFactor

        Rectangle {
            id: step3ProfileBackground
            color: Qt.rgba(0.0,0.0,0.0,0.0)
            width: parent.width
            height: parent.height
            anchors.left: parent.left
            anchors.top: parent.top

            TextLabel {
                id: profileBackgroundTitle
                anchors.top: profile1View.bottom
//                anchors.topMargin: 30 * main.vScaleFactor
                anchors.horizontalCenter: step3ProfileBackground.horizontalCenter
                text: qsTr("CUSTOM WORKOUT PROFILE") + application.emptyString
                font.pixelSize: 12 * main.vScaleFactor
                smooth: true
            }

            GraphView {
                id: profile1View
                anchors {
                    left: parent.left
                    leftMargin: 10 * main.hScaleFactor
                    right: parent.right
                    rightMargin: 10 * main.hScaleFactor
                    top: parent.top
                    topMargin: 0
                    bottom: parent.bottom
                    bottomMargin: 0
                }
                model1: profile1model
                model2: profile2model
                columnWidth: model1.count <=30 ? summaryProfileGraph.width / (model1.count*2.5) : 80 * main.hScaleFactor
                segmentFill: 100
                activeSegment: model1.count
                editable: false
                isSummary: true
                z:4
            }
        }
    }
}
