import QtQuick 2.12
import QtQuick.Layouts 1.12
//import QtAV 1.6
import QtMultimedia 5.7
import Components 1.0

Item {
    id: root
    property string mrl: ""

    anchors.fill: parent
    clip: true

    function stop() {
        videoArtwork.stopVideo()
    }

    function start() {
        videoArtwork.startVideo()
    }

    function pause() {
        videoArtwork.pause()
    }

    Video {
        id: videoArtwork
        fillMode: VideoOutput.PreserveAspectFit
        autoPlay: true

        function startVideo() {
            videoArtwork.source = root.mrl
            videoArtwork.seek(1)
            videoArtwork.play()
        }

        function stopVideo() {
            videoArtwork.stop()
            videoArtwork.source = ""
        }

        anchors.fill: parent
        muted: true
//        backgroundColor: "transparent"
//        videoCodecPriority: ["FFmpeg"]

        onPlaybackStateChanged: {
            if (videoArtwork.playbackState === MediaPlayer.PlayingState) {
                console.log("C360video playing: " + videoArtwork.source)
            } else {
                console.log("C360video not playing: " + videoArtwork.source)
            }
        }

        loops: MediaPlayer.Infinite
//        onPositionChanged: {
//            // Loop video if the end has been reached
//            if(position >= (duration - 500)) {
//                startVideo()
//            }
//        }
    }
}
