import QtQuick 2.12
import ProcessContainer 1.0
import Process 0.1
import Components 1.0
import QtQuick.Layouts 1.12

import ".."
import "../Keypad"

Item {
    id: root

    property string url
    property bool keyingURL: false
    property string defaultURL: options.homeURL
    property int currentContentWidth:0
    property color colorBorder: main.colorUIBorder
    property color colorBackground: main.colorDialogBackground
    property color colorUrlBar: "#ffffff"
    property bool hasBeenShown: false
   // property bool frozen: workoutScreen.state === "" || workoutScreen.state === "ResetInclineKP"|| workoutScreen.state === "ResetSpeedKP" || workoutScreen.state === "ResetLevelKP" || !workoutScreen.speedVisible || !workoutScreen.inclineVisible  ? false : true
    property bool isMenuDisplayed: false
    property alias isMenuMoving: menuView.moving

    property bool frozen: setFrozenState()

    signal action()


    clip: false

    function viewdestruct() {
        console.log("WebViewContainer: Destroy view")
        root.url = ""
        browserProcess.kill()
        browserAudioWatcher.kill()
    }
    function setFrozenState()
    {
        console.log(":::::::::::::::::::::::::::::::::::::in frozen state function")
       // if(workoutScreen.state === "" ||workoutScreen.state === "ResetLevelKP")
        if(workoutScreen.state === "" )
        {
            return false
        }
      /*  else if(workoutScreen.state === "ResetInclineKP")
        {
            if(workoutScreen.speedVisible)
            {
                return true
            }
            else{
           return false
            }
        }
        else if(workoutScreen.state === "ResetSpeedKP")
        {
            if(workoutScreen.inclineVisible)
            {
                return true
            }
            else
                return false
        }*/
        return true
    }

    function shown() {
        root.hasBeenShown = true
        if (browserAudioWatcher.soundIsPlaying)
            audioManager.browserRequest()
        else
            audioManager.btRequest()
        workoutViewContainer.persistMenu = true;
    }

    function hidden() {
        browserProcess.write("CMD hidden\n")
        //urlKeypad.process.write("CMD hide\n")
        //inputKeypad.process.write("CMD hide\n")
        workoutScreen.browserFullscreen = false
        workoutViewContainer.persistMenu = false;
    }

    function initializeURLlist() {
        urlList.clear()

        if(options.homeURL !== options.defaults.homeURLDefault) {
            var newitem = {
                "name" : "home",
                "label": "Home",
                "url": options.homeURL
            }
            urlList.append(newitem)
        }
        var i
        if(options.browserCountryCode === "nz") {
            for(i = 0; i < urlListNZDefault.count; i++) {
                urlList.append(urlListNZDefault.get(i));
            }
        } else if (options.browserCountryCode === "au") {
            for(i = 0; i < urlListAUDefault.count; i++) {
                urlList.append(urlListAUDefault.get(i));
            }
        } else if (options.browserCountryCode === "no") {
            for(i = 0; i < urlListNODefault.count; i++) {
                urlList.append(urlListNODefault.get(i));
            }
        } else {
            for(var i = 0; i < urlListDefault.count; i++) {
                urlList.append(urlListDefault.get(i));
            }
        }
    }

    Component.onCompleted: initializeURLlist()

    Connections {
        target: options
        onHomeURLChanged: {
            initializeURLlist()
        }
    }

    Connections {
        target: application

        onMainViewFocusChanged: {
            if (isFocused) {
            //    urlKeypad.process.write("CMD hide\n")
            //    inputKeypad.process.write("CMD hide\n")
            }
        }
    }

    ListModel {
        id: urlList
    }
    ListModel {
        id: urlListNZDefault
        ListElement {name:"true"; label:"TRUE"; url:"http://www.truefitness.com"}
        ListElement {name:"links"; label:"LINKS"; url:"https://software.truefitness.com/console-links_2.0/index.html"}
        ListElement {name:"google"; label:"GOOGLE"; url:"https://www.google.co.nz"}
        ListElement {name:"reddit"; label:"REDDIT"; url:"http://www.reddit.com"}
        ListElement {name:"facebook"; label:"FACEBOOK"; url:"http://www.facebook.com"}
        ListElement {name:"twitter"; label:"TWITCH.TV"; url:"https://www.twitch.tv"}
        ListElement {name:"youtube"; label:"YOUTUBE"; url:"https://www.youtube.com"}
        ListElement {name:"netflix"; label:"NETFLIX"; url:"https://www.netflix.com"}
        ListElement {name:"skygo"; label:"SKY GO"; url:"http://skygo.co.nz"}
        ListElement {name:"tvnz"; label:"ON DEMAND"; url:"http://tvnz.co.nz/shows"}
        ListElement {name:"threenow"; label:"THREE NOW"; url:"http://threenow.co.nz"}
        ListElement {name:"iheart"; label:"IHEART"; url:"http://iheart.com"}
        ListElement {name:"instagram"; label:"INSTAGRAM"; url:"http://instagram.com"}
        ListElement {name:"wikipedia"; label:"WIKIPEDIA"; url:"https://wikipedia.com"}
        ListElement {name:"trademe"; label:"TRADE ME"; url:"https://trademe.co.nz"}
        ListElement {name:"stuff"; label:"STUFF"; url:"http://stuff.co.nz"}
        ListElement {name:"nzherald"; label:"NZ HERALD"; url:"https://nzherald.co.nz"}
    }

    ListModel {
        id: urlListAUDefault
        ListElement {name:"true"; label:"TRUE"; url:"http://www.truefitness.com"}
        ListElement {name:"links"; label:"LINKS"; url:"https://software.truefitness.com/console-links_2.0/index.html"}
        ListElement {name:"google"; label:"GOOGLE.COM"; url:"https://www.google.com"}
        ListElement {name:"espn"; label:"ESPN.COM"; url:"http://www.espn.com/watch/"}
        ListElement {name:"facebook"; label:"FACEBOOK.COM"; url:"http://www.facebook.com"}
        ListElement {name:"twitter"; label:"TWITTER.COM"; url:"https://twitter.com"}
        ListElement {name:"netflix"; label:"NETFLIX.COM"; url:"https://www.netflix.com"}
        ListElement {name:"youtube"; label:"YOUTUBE.COM"; url:"https://www.youtube.com"}
        ListElement {name:"amazon"; label:"AMAZON.COM"; url:"http://www.amazon.com"}
        ListElement {name:"hulu"; label:"HULU.COM"; url:"http://www.hulu.com"}
        ListElement {name:"starz"; label:"STARZ.COM"; url:"http://www.starz.com"}
        ListElement {name:"fandango-now"; label:"FANDANGONOW.COM"; url:"http://www.fandangonow.com"}
        ListElement {name:"instagram"; label:"INSTAGRAM.COM"; url:"http://instagram.com"}
        ListElement {name:"pintrest"; label:"PINTREST.COM"; url:"https://www.pinterest.com"}
        ListElement {name:"linkedin"; label:"LINKEDIN.COM"; url:"https://www.linkedin.com"}
        ListElement {name:"news"; label:"NEWS.COM"; url:"http://www.news.com.au"}
        ListElement {name:"foxnews"; label:"FOXNEWS.COM"; url:"https://www.foxnews.com"}
    }

    ListModel {
        id: urlListNODefault
        ListElement {name:"true"; label:"TRUE"; url:"http://www.truefitness.com"}
        ListElement {name:"links"; label:"LINKS"; url:"https://software.truefitness.com/console-links_2.0/index.html"}
        ListElement {name:"google"; label:"GOOGLE.COM"; url:"https://www.google.com"}
        ListElement {name:"espn"; label:"ESPN.COM"; url:"http://www.espn.com/watch/"}
        ListElement {name:"facebook"; label:"FACEBOOK.COM"; url:"http://www.facebook.com"}
        ListElement {name:"twitter"; label:"TWITTER.COM"; url:"https://twitter.com"}
        ListElement {name:"netflix"; label:"NETFLIX.COM"; url:"https://www.netflix.com/no"}
        ListElement {name:"youtube"; label:"YOUTUBE.COM"; url:"https://www.youtube.com"}
        ListElement {name:"amazon"; label:"AMAZON.COM"; url:"http://www.amazon.com"}
        ListElement {name:"hulu"; label:"HULU.COM"; url:"http://www.hulu.com"}
        ListElement {name:"starz"; label:"HBONORDIC.COM"; url:"https://no.hbonordic.com"}
        ListElement {name:"fandango-now"; label:"VIAPLAY.NO"; url:"https://viaplay.no"}
        ListElement {name:"instagram"; label:"INSTAGRAM.COM"; url:"http://instagram.com"}
        ListElement {name:"pintrest"; label:"DPLAY.NO"; url:"https://www.dplay.no"}
        ListElement {name:"linkedin"; label:"RIKSTV.NO"; url:"https://www.rikstv.no"}
        ListElement {name:"cnn"; label:"SUMOTV2.NO"; url:"https://sumo.tv2.no/velkommen"}
        ListElement {name:"foxnews"; label:"NRK.NO"; url:"https://tv.nrk.no"}
    }

    ListModel {
        id: urlListDefault
        ListElement {name:"true"; label:"TRUE"; url:"http://www.truefitness.com"}
        ListElement {name:"links"; label:"LINKS"; url:"https://software.truefitness.com/console-links_2.0/index.html"}
        ListElement {name:"google"; label:"GOOGLE.COM"; url:"https://www.google.com"}
        ListElement {name:"espn"; label:"ESPN.COM"; url:"http://www.espn.com/watch/"}
        ListElement {name:"facebook"; label:"FACEBOOK.COM"; url:"http://www.facebook.com"}
        ListElement {name:"twitter"; label:"TWITTER.COM"; url:"https://twitter.com"}
        ListElement {name:"netflix"; label:"NETFLIX.COM"; url:"https://www.netflix.com"}
        ListElement {name:"youtube"; label:"YOUTUBE.COM"; url:"https://www.youtube.com"}
        ListElement {name:"amazon"; label:"AMAZON.COM"; url:"http://www.amazon.com"}
        ListElement {name:"hulu"; label:"HULU.COM"; url:"http://www.hulu.com"}
        ListElement {name:"starz"; label:"STARZ.COM"; url:"http://www.starz.com"}
        ListElement {name:"fandango-now"; label:"FANDANGONOW.COM"; url:"http://www.fandangonow.com"}
        ListElement {name:"instagram"; label:"INSTAGRAM.COM"; url:"http://instagram.com"}
        ListElement {name:"pintrest"; label:"PINTREST.COM"; url:"https://www.pinterest.com"}
        ListElement {name:"linkedin"; label:"LINKEDIN.COM"; url:"https://www.linkedin.com"}
        ListElement {name:"cnn"; label:"CNN.COM"; url:"http://www.cnn.com"}
        ListElement {name:"foxnews"; label:"FOXNEWS.COM"; url:"https://www.foxnews.com"}
    }

    ProcessContainer {
        id: processContainer

        width: workoutScreen.browserFullscreen ? main.width - linksMenu.width : root.width - linksMenu.width - (main.screenWidth * 139 / 1920) - (main.widthBorder * 2)
        height: workoutScreen.browserFullscreen ? main.height : root.height -  (main.widthBorder * 2)
        globalX: workoutScreen.browserFullscreen ? linksMenu.width : root.parent.parent.mapToGlobal(root.parent.parent.x, root.parent.parent.y).x + linksMenu.width + (main.widthBorder * 1.5)
        globalY: workoutScreen.browserFullscreen ? 0 : root.parent.parent.mapToGlobal(root.parent.parent.x, root.parent.parent.y).y + (main.widthBorder * 1.5)
        anchors.top: parent.top
        anchors.topMargin: main.widthBorder
        anchors.left: linksMenu.right
        visible: true
        frozen: { !visible ||
                  workoutScreen.currentViewName !== "WEB_VIEW" ||
                  stopPrompt.visible ||
                  dialogManager.anyAreShown ||
                  root.frozen
        }
        readyForImage: root.hasBeenShown

        onFrozenChanged: {
            console.debug("Frozen changed:::::::::::::::::::::::::::::::::::::::::::::::::::: " + frozen + " xywh: " + processContainer.globalX + " " + processContainer.globalY + " " + processContainer.width + " " + processContainer.height)
            if (!frozen) {
                browserProcess.write("CMD readyToShow\n")
            }
        }
        onEmbedded: {
            if (!frozen) {
                // Force embedded window to re-call show(), so that the show flag
                // gets set and future hide calls work
                visibleChanged(true)
                browserProcess.write("CMD readyToShow\n")
            }
        }

        Component.onCompleted: processContainer.createContainer()
    }

    Process {
        id: browserProcess
        program: "scripts/start_browser.sh"

        arguments: ["--home-url", options.homeURL, "--language", application.currentLanguage]
        onStarted: {
            browserAudioWatcher.start()
        }
        onReadyReadStandardOutput: {
            var data = (String(readAllStandardOutput())).trim()
            console.log("BrowserProcess (STDOUT):",data)
            if (data.indexOf("CMD winid") >= 0) {
                var parts = data.split(" ")
                var winid = parseInt(parts[2], 10)
                processContainer.winid = winid
            } else if (data.indexOf("CMD didShow") >= 0) {
                processContainer.readyToShow = true
            }
        }
        onReadyReadStandardError: {
            var data = (String(readAllStandardError())).trim()
            console.log("BrowserProcess (STDERR):",data)
            if (data.indexOf("CMD fullscreen") >= 0) {
                workoutScreen.browserFullscreen = !workoutScreen.browserFullscreen
            }
        }
        onFinished: {
            console.log("BrowserProcess: Restarting browser")
            processContainer.readyToShow = false
            restart()
        }
        Component.onCompleted: start()
    }

    Rectangle {
        id: linksMenu
        width: workoutScreen.browserFullscreen ? main.width * 0.15 : root.width * 0.15
        anchors.left: workoutScreen.browserFullscreen ? main.left : root.left
        anchors.top: workoutScreen.browserFullscreen ? main.top : root.top
        anchors.bottom: workoutScreen.browserFullscreen ? main.bottom : root.bottom
        anchors.margins: 1.5 * main.widthBorder
        color: main.colorDialogBackground

        visible: !root.fullscreen && opacity > 0
        opacity: isMenuDisplayed || workoutScreen.browserFullscreen === true ? 1.0 : 0

        Connections {
            target: workoutScreen
            onBrowserFullscreenChanged: {
                if(workoutScreen.browserFullscreen) {
                    linksMenu.parent = main
                    linksMenu.width = main.width * 0.15
                    linksMenu.anchors.left = main.left
                    linksMenu.anchors.top = main.top
                    linksMenu.anchors.bottom = main.bottom
                } else {
                    linksMenu.parent = root
                    linksMenu.width = root.width * 0.15
                    linksMenu.anchors.left = root.left
                    linksMenu.anchors.top = root.top
                    linksMenu.anchors.bottom = root.bottom
                }
            }
        }

        Item {
            anchors.fill: parent
            anchors.margins: 10 * main.scaleFactor
            ColumnLayout {
                anchors.fill: parent
                spacing: 5* main.vScaleFactor

                Item {
                    id: listArea

                    Layout.fillWidth: true
                    Layout.fillHeight: true
                    Layout.alignment: Qt.AlignHCenter | Qt.AlignTop

                    ListView {
                        id: menuView
                        anchors.fill: parent
                        anchors.horizontalCenter: parent.horizontalCenter
                        anchors.verticalCenter: parent.verticalCenter
                        model: urlList
                        delegate: menuButtonDelegate
                        spacing: 8 * main.vScaleFactor
                        clip: true
                    }
                }

                Item {
                    id: controlArea

                    Layout.fillWidth: true
                    Layout.preferredHeight: 0.8*parent.width / 2 * controlGrid.rows
                    Layout.alignment: Qt.AlignHCenter | Qt.AlignBottom

                    GridLayout {
                        id: controlGrid

                        anchors.fill: parent
                        rows: 3
                        rowSpacing: 7 * main.hScaleFactor
                        columns: 2
                        columnSpacing: 7 * main.vScaleFactor

                        property real delegateWidth: (width-columnSpacing)/columns
                        property real delegateHeight: (height-rowSpacing)/rows

                        Repeater {
                            model: controlsList
                            delegate: controlButtonDelegate
                        }

                        Component {
                            id: controlButtonDelegate
                            Item {
                                Layout.preferredWidth: controlGrid.delegateWidth
                                Layout.preferredHeight: controlGrid.delegateHeight
                                opacity: 1

                                StandardButton {
                                    anchors.fill: parent
                                    sourceName: workoutScreen.browserFullscreen && model.name === "BrowserFullScreen" ? "UpperToolBar/collapse_icon" : model.iconPath
                                    buttonText: qsTr(model.label) + application.emptyString
                                    selected: volume_controls.muted && model.name === "VolumeMute"
                                    color: selected ? main.colorSelected : root.colorBackground
                                    enabled: root.isMenuDisplayed || workoutScreen.browserFullscreen === true
                                    onClicked: {
                                        controlClicked(model.name)
                                        root.action()
                                    }
                                }
                            }
                        }
                    } // end GridLayout
                } // end Item
            } // end ColumnLayout
        }
    } // end Item

    Component {
        id: menuButtonDelegate

        Item {
            height: ListView.view.height * 0.2
            width: ListView.view.width
            opacity: 1

            Rectangle {
                color: colorBackground
                height: parent.height
                width: parent.width
                radius: main.defaultRadius
                border.color: colorBorder
                border.width: main.widthBorder
                anchors.horizontalCenter: parent.horizontalCenter

                Text {
                    anchors.fill: parent
                    horizontalAlignment: Text.AlignHCenter
                    verticalAlignment: Text.AlignVCenter
                    text: model.label
                    wrapMode: Text.WordWrap
                    clip: true
                    color:main.colorFontLight
                    font {
                        bold: true;
                        pixelSize: 10 * main.vScaleFactor;
                    }
                }

                MouseArea {
                    anchors.fill: parent
                    enabled: isMenuDisplayed || workoutScreen.browserFullscreen === true
                    onClicked: {
                        var url
                        if(model.name === "links") {
                            url = model.url + "?country=" + options.browserCountryCode
                        } else {
                            url = model.url
                        }

                        browserProcess.write("CMD url " + url + "\n")
                        console.log("Browser Command: CMD url " + url + "\n" )
                        root.action()
                    }

                    Rectangle {
                        anchors.fill: parent
                        color: main.colorGenericStimulusArea
                        opacity: 0.3
                        visible: main.showStimulusArea
                    }
                }
            }
        }
    }

    ListModel {
        id: controlsList
        ListElement {
            name: "BrowserBack"
            label: ""
            iconPath: "Media/Back_Triangle"
        }
        ListElement {
            name: "BrowserForward"
            label: ""
            iconPath: "Media/Forward_Triangle"
        }
        ListElement {
            name: "VolumeDown"
            label: QT_TR_NOOP("VOL")
            iconPath: "Media/Media_Volume_Minus"
        }
        ListElement {
            name: "VolumeUp"
            label: QT_TR_NOOP("VOL")
            iconPath: "Media/Media_Volume_Plus"
        }
//        ListElement {
//            name: "BrowserHome"
//            label: ""
//            iconPath: "Components/HomeIcon"
//        }
        ListElement {
            name: "BrowserFullScreen"
            label: ""
            iconPath: "UpperToolBar/expand_icon"
        }
        ListElement {
            name: "VolumeMute"
            label: ""
            iconPath: "Media/Media_Mute_Up"
        }
    }

    function controlClicked(name)
    {
        root.action()
        if(name === "BrowserBack") {
            browserProcess.write("CMD goback\n")
        } else if(name === "BrowserForward") {
            browserProcess.write("CMD goforward\n")
        } else if(name === "VolumeDown") {
            volume_controls.volumeDown();
        } else if(name === "VolumeUp") {
            volume_controls.volumeUp();
        } else if(name === "VolumeMute") {
            volume_controls.toggleMute();
//        } else  if(name === "BrowserHome") {
//            browserProcess.write("CMD gohome\n")
        } else if(name === "BrowserFullScreen") {
            workoutScreen.browserFullscreen = !workoutScreen.browserFullscreen
        }
    }
}
